/*******************************************************************************
 * Copyright (c) 2009 itemis AG (http://www.itemis.eu) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.xtext.grammaranalysis;

import java.util.List;

import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.grammaranalysis.IGrammarNFAProvider.NFABuilder;

/**
 * @author Moritz Eysholdt - Initial contribution and API
 */
@SuppressWarnings("unchecked")
public interface INFAState<S extends INFAState, T extends INFATransition> {
	public NFABuilder<S, T> getBuilder();

	public AbstractElement getElement();

	public List<T> getFollowers();

	public List<T> getParentFollowers();

	public boolean isEndState();

	public boolean isStartState();
}
